%global _hardened_build 1
%global commit 3ee15e65aa14a8aa661c522c5fb183a0fdfed8b3

Name:           zerotier-one
Version:        1.1.5
Release:        0.4%{?dist}
Summary:        ZeroTier is a software defined networking layer for Earth

License:        GPLv3
URL:            https://zerotier.com
# https://fedoraproject.org/wiki/Packaging:SourceURL
Source0:        https://github.com/zerotier/ZeroTierOne/archive/%{commit}.tar.gz

Patch0:         %{name}-add-cmake.patch
Patch1:         %{name}-use-system-miniupnpc.patch

BuildRequires:  cmake
BuildRequires:  miniupnpc-devel >= 2.0
BuildRequires:  http-parser-devel >= 2.6
BuildRequires:  lz4-devel
BuildRequires:  json-parser-devel
BuildRequires:  libnatpmp-devel
BuildRequires:  systemd
BuildRequires:  sqlite-devel

# to generate the manpages
BuildRequires:  rubygem-ronn

# XXX: these "Requires" may not even be necessary as they are picked up 
# automatically by dnf/yum @ install
Requires:       miniupnpc >= 2.0
Requires:       http-parser >= 2.6
Requires:       lz4
Requires:       json-parser
Requires:       libnatpmp
Requires:       sqlite

%description
ZeroTier is a software defined networking layer for Earth.

It can be used for on-premise network virtualization, as a peer to peer VPN 
for mobile teams, for hybrid or multi-data-center cloud deployments, or just 
about anywhere else secure software defined virtual networking is useful.

ZeroTier One is our OS-level client service. It allows Mac, Linux, Windows, 
FreeBSD, and soon other types of clients to join ZeroTier virtual networks 
like conventional VPNs or VLANs. It can run on native systems, VMs, or 
containers (Docker, OpenVZ, etc.).

%prep
%setup -qn ZeroTierOne-%{commit} 

# delete the ext directory to make sure we do not use it for build
rm -rf ext/

%patch0 -p1
%patch1 -p1

%build
%cmake .
make VERBOSE=1 %{?_smp_mflags}

# build the manpages
(
cd doc
./build.sh
)

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_unitdir}
cp debian/zerotier-one.service $RPM_BUILD_ROOT%{_unitdir}/%{name}.service

mkdir -p $RPM_BUILD_ROOT%{_mandir}/{man1,man8}
cp doc/*.1 $RPM_BUILD_ROOT%{_mandir}/man1/
cp doc/*.8 $RPM_BUILD_ROOT%{_mandir}/man8/

%files
%{_sbindir}/*
%{_mandir}/man1/*
%{_mandir}/man8/*
%{_unitdir}/%{name}.service
%doc AUTHORS.md README.md
%license LICENSE.GPL-3

%changelog
* Tue Jun 21 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.4
- require sqlite
- point to commit instead of branch
- include manpage
- update cmake build file to also build controller by default

* Wed Jun 08 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.3
- include systemd unit file

* Wed Jun 08 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.2
- add libnatpmp as (build)dependency

* Wed Jun 08 2016 François Kooman <fkooman@tuxed.net> - 1.1.5-0.1
- initial package
